#include <windows.h>
#include <stdio.h>

#define CMD_COMMANDS            0x01
#define CMD_DONE                0x02
#define CMD_SET_CABLE_MODE      0x03
#define CMD_CLOSE_CABLE         0x04
#define CMD_GET_INFO            0x05
#define CMD_SET_CABLE_OPTION    0x06
#define CMD_GET_CABLE_OPTION    0x07
#define CMD_IS_CONNECTED        0x11
#define CMD_READ                0x20
#define CMD_WRITE               0x21
#define CMD_SET_PIN             0x25
#define CMD_PULSE_PIN           0x26
#define CMD_START_OPERATION     0x30
#define CMD_NAVIGATE_TAP        0x31
#define CMD_WAIT_TIME           0x35
#define CMD_CHECK_SERVER        0x70

#define sock_send(sock, buff, len)  send(sock, (const char*)buff, len, 0)
#define sock_recv(sock, buff, len)  recv(sock, (char*)buff, len, 0)

int connect_to_server()
{
    struct sockaddr_in addr;
    int sock;
    
    sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (sock < 0)
    {
        tracef(1, "socket() failed!\n");
        return -1;
    }
      
    memset(&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = inet_addr("127.0.0.1");
    addr.sin_port = htons(2000);
    
    if (connect(sock, (struct sockaddr*)&addr, sizeof(addr)) < 0)
    {
        closesocket(sock);
        return -1;
    }

    return sock;
}

int main(int, char**)
{
    WSADATA wsa;
    int sock = -1, rc = -1;
    unsigned char v8;
    //short v16;
    int v;

    WSAStartup(MAKEWORD(2,2), &wsa);

    //

    sock = connect_to_server();
    
    v8 = CMD_SET_CABLE_MODE;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    v = 3;
    sock_send(sock, &v, sizeof(v));
    sock_send(sock, "LPT", v);
    v = 0;
    sock_send(sock, &v, sizeof(v));
    v = 200000;
    sock_send(sock, &v, sizeof(v));
    v = 0;
    sock_send(sock, &v, sizeof(v));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, sizeof(v8));

    closesocket(sock);

    //
    
    sock = connect_to_server();

    v8 = CMD_COMMANDS;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    v = 0;
    sock_send(sock, &v, sizeof(v));
    v = 0;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_IS_CONNECTED;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_SET_CABLE_OPTION;
    sock_send(sock, &v8, sizeof(v8));
    v = 5;
    sock_send(sock, &v, sizeof(v));
    sock_send(sock, "power", v);
    v = 4;
    sock_send(sock, &v, sizeof(v));
    sock_send(sock, "true", v);
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_START_OPERATION;
    sock_send(sock, &v8, sizeof(v8));
    v = 0;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_WRITE;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 96;
    sock_send(sock, &v8, sizeof(v8));
    v = 8;
    sock_send(sock, &v, sizeof(v));
    v8 = 1;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0xFF;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 1;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0xFF;
    sock_send(sock, &v8, sizeof(v8));

    v = 8;
    sock_send(sock, &v, sizeof(v));
    v8 = 1;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0xFF;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_READ;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 224;
    sock_send(sock, &v8, sizeof(v8));
    v = 8;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, 1);

    v8 = CMD_SET_CABLE_OPTION;
    sock_send(sock, &v8, sizeof(v8));
    v = 5;
    sock_send(sock, &v, sizeof(v));
    sock_send(sock, "power", v);
    v = 5;
    sock_send(sock, &v, sizeof(v));
    sock_send(sock, "false", v);
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_DONE;
    sock_send(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, sizeof(v8));

    closesocket(sock);

    //

    sock = connect_to_server();
    
    v8 = CMD_CLOSE_CABLE;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 0;
    sock_send(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, sizeof(v8));

    closesocket(sock);
    
    //

    rc = 0;

    WSACleanup();

    return 0;
}

/*
    v8 = CMD_NAVIGATE_TAP;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 5;
    sock_send(sock, &v8, sizeof(v8));
    v8 = 1;
    sock_send(sock, &v8, sizeof(v8));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_SET_PIN;
    sock_send(sock, &v8, sizeof(v8));
    v = 13;
    sock_send(sock, &v, sizeof(v));
    v = 1;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_SET_PIN;
    sock_send(sock, &v8, sizeof(v8));
    v = 13;
    sock_send(sock, &v, sizeof(v));
    v = 0;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));

    v8 = CMD_PULSE_PIN;
    sock_send(sock, &v8, sizeof(v8));
    v = 12;
    sock_send(sock, &v, sizeof(v));
    v = 5;
    sock_send(sock, &v, sizeof(v));
    sock_recv(sock, &v8, sizeof(v8));
    */